## sdl2-compat 2.30.50+ds

=== CMakeLists.txt ===
# NOTE:  If you installed SDL3 at an unusual place and SDL3Config fails,
#        you can define SDL3_INCLUDE_DIRS on the cmdline.  For example:
#        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]

cmake_minimum_required(VERSION 3.0...3.28)
project(sdl2_compat VERSION 2.30.50 LANGUAGES C)

if(POLICY CMP0074)
  # CMP0074: find_package() uses <PackageName>_ROOT variables.
  cmake_policy(SET CMP0074 NEW)
endif()

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  set(SDL2COMPAT_MAINPROJECT ON)
  set(SDL2COMPAT_SUBPROJECT OFF)
else()
  set(SDL2COMPAT_MAINPROJECT OFF)
  set(SDL2COMPAT_SUBPROJECT ON)
endif()

if(CMAKE_VERSION VERSION_LESS 3.16.0 OR SDL2COMPAT_SUBPROJECT)
  # - CMake versions <3.16 do not support the OBJC language
  # - When SDL is built as a subproject and when the main project does not enable OBJC,
  #   CMake fails due to missing internal CMake variables (CMAKE_OBJC_COMPILE_OBJECT)
  #   (reproduced with CMake 3.24.2)
else()
  if(APPLE)
    enable_language(OBJC)
  endif()
endif()

set(SDL_MAJOR_VERSION ${sdl2_compat_VERSION_MAJOR})
set(SDL_MINOR_VERSION ${sdl2_compat_VERSION_MINOR})
set(SDL_MICRO_VERSION ${sdl2_compat_VERSION_PATCH})
set(SDL_VERSION "${SDL_MAJOR_VERSION}.${SDL_MINOR_VERSION}.${SDL_MICRO_VERSION}")

include(CheckCSourceCompiles)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckLanguage)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(CMakeParseArguments)
include(CMakePushCheckState)
include(GNUInstallDirs)
include("${CMAKE_CURRENT_LIST_DIR}/cmake/CheckCPUArchitecture.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/cmake/macros.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/cmake/sdlchecks.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/cmake/sdlcompilers.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/cmake/sdlplatform.cmake")

# Calculate libtool-compatible SO version
set(SDL_SO_VERSION_MAJOR "0")
if(SDL_MINOR_VERSION MATCHES "[02468]$")
  # Stable branch, 2.24.1 -> libSDL2-2.0.so.0.2400.1
  math(EXPR SDL_SO_VERSION_MINOR "${SDL_MINOR_VERSION} * 100")
  set(SDL_SO_VERSION_MICRO ${SDL_MICRO_VERSION})
else()
  # Development branch, 2.23.1 -> libSDL2-2.0.so.0.2301.0
  math(EXPR SDL_SO_VERSION_MINOR "${SDL_MINOR_VERSION} * 100 + ${SDL_MICRO_VERSION}")
  set(SDL_SO_VERSION_MICRO 0)
endif()
set(SDL_SO_VERSION "${SDL_SO_VERSION_MAJOR}.${SDL_SO_VERSION_MINOR}.${SDL_SO_VERSION_MICRO}")

if(SDL_MINOR_VERSION MATCHES "[02468]$")
  math(EXPR SDL_DYLIB_COMPAT_VERSION_MAJOR "100 * ${SDL_MINOR_VERSION} + 1")
  set(SDL_DYLIB_COMPAT_VERSION_MINOR "0")
  math(EXPR SDL_DYLIB_CURRENT_VERSION_MAJOR "${SDL_DYLIB_COMPAT_VERSION_MAJOR}")
  set(SDL_DYLIB_CURRENT_VERSION_MINOR "${SDL_MICRO_VERSION}")
else()
  math(EXPR SDL_DYLIB_COMPAT_VERSION_MAJOR "100 * ${SDL_MINOR_VERSION} + ${SDL_MICRO_VERSION} + 1")
  set(SDL_DYLIB_COMPAT_VERSION_MINOR "0")
  math(EXPR SDL_DYLIB_CURRENT_VERSION_MAJOR "${SDL_DYLIB_COMPAT_VERSION_MAJOR}")
  set(SDL_DYLIB_CURRENT_VERSION_MINOR "0")
endif()
set(SDL_DYLIB_COMPAT_VERSION_MICRO "0")
set(SDL_DYLIB_CURRENT_VERSION_MICRO "0")

set(SDL_DYLIB_CURRENT_VERSION "${SDL_DYLIB_CURRENT_VERSION_MAJOR}.${SDL_DYLIB_CURRENT_VERSION_MINOR}.${SDL_DYLIB_CURRENT_VERSION_MICRO}")
set(SDL_DYLIB_COMPAT_VERSION "${SDL_DYLIB_COMPAT_VERSION_MAJOR}.${SDL_DYLIB_COMPAT_VERSION_MINOR}.${SDL_DYLIB_COMPAT_VERSION_MICRO}")

option(SDL2COMPAT_TESTS "Enable to build SDL2 test programs" ${SDL2COMPAT_MAINPROJECT})
option(SDL2COMPAT_INSTALL "Enable installing SDL2-compat" ${SDL2COMPAT_MAINPROJECT})
cmake_dependent_option(SDL2COMPAT_INSTALL_CPACK "Create binary SDL2_compat archive using CPack" ${SDL2COMPAT_MAINPROJECT} "SDL2COMPAT_INSTALL" OFF)
cmake_dependent_option(SDL2COMPAT_INSTALL_TESTS "Install test-cases" OFF "SDL2COMPAT_INSTALL;SDL2COMPAT_TESTS" OFF)
cmake_dependent_option(SDL2COMPAT_INSTALL_SDL3 "Install SDL3 next to SDL2" OFF "WIN32;SDL2COMPAT_INSTALL" OFF)
option(SDL2COMPAT_STATIC "Enable building static SDL2 link library" OFF)
option(SDL2COMPAT_WERROR "Treat warnings as errors" OFF)
set(SDL2COMPAT_VENDOR_INFO "" CACHE STRING "Vendor name and/or version to add to SDL_REVISION")
set(SDL2COMPAT_FRAMEWORK FALSE)
#FIXME: should SDL2-compat modify vendor_info/revision information?

if(SDL2COMPAT_STATIC AND NOT (CMAKE_SYSTEM_NAME MATCHES "Linux"))
  message(FATAL_ERROR "Static builds are only supported on Linux.")
endif()

SDL_DetectCompiler()
SDL_DetectCPUArchitecture()
SDL_DetectCMakePlatform()
CheckOpenGLES()

if(NOT MSVC AND NOT APPLE AND NOT OPENBSD)
  cmake_push_check_state()
  set(CMAKE_REQUIRED_FLAGS "-Wl,--no-undefined")
  check_c_compiler_flag("" HAVE_NO_UNDEFINED)
  cmake_pop_check_state()
  if(HAVE_NO_UNDEFINED)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-undefined")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
  endif()
endif()

if(NOT TARGET SDL3::Headers)
  find_package(SDL3 QUIET COMPONENTS Headers)
endif()

if(NOT TARGET SDL3::Headers)
  find_path(SDL3_INCLUDE_DIRS
    NAMES "SDL3/SDL.h"
  )
  if(NOT SDL3_INCLUDE_DIRS)
    message(FATAL_ERROR "Cannot find SDL3 headers: configure with -DCMAKE_PREFIX_PATH=\"/root/to/SDL3\" or -DSDL3_INCLUDE_DIRS=\"/root/to/SDL3/include\"")
  endif()
  add_library(SDL3::Headers INTERFACE IMPORTED)
  set_property(TARGET SDL3::Headers PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${SDL3_INCLUDE_DIRS}")
endif()

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/REVISION.txt")
  file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/REVISION.txt" REVISION_txt_lines)
  list(GET REVISION_txt_lines 0 SDL_REVISION)
else()
  find_package(Git)
  if(Git_FOUND)
    execute_process(
      COMMAND "${GIT_EXECUTABLE}" describe --always --tags --long
      WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
      RESULT_VARIABLE GIT_REVISION_STATUS
      OUTPUT_VARIABLE GIT_REVISION
      ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
  else()
    set(GIT_REVISION_STATUS 1)
    set(GIT_REVISION "")
  endif()

  if(GIT_REVISION_STATUS EQUAL 0)
    if(GIT_REVISION MATCHES "^[0-9a-f]+$")
      # Just a truncated sha1, so prefix it with the version number
      set(SDL_REVISION "SDL-${SDL_VERSION}-g${GIT_REVISION}")
    else()
      # e.g. release-2.24.0-542-g96361fc47
      set(SDL_REVISION "SDL-${GIT_REVISION}")
    endif()
  else()
    set(SDL_REVISION "SDL-${SDL_VERSION}-no-vcs")
  endif()
endif()

if(SDL2COMPAT_VENDOR_INFO)
  set(SDL2COMPAT_REVISION "${SDL_REVISION} (${SDL2COMPAT_VENDOR_INFO})")
else()
  set(SDL2COMPAT_REVISION "${SDL_REVISION}")
endif()
configure_file(include/SDL2/SDL_revision.h.cmake include/SDL2/SDL_revision.h @ONLY)

set(SDL2COMPAT_SRCS
  src/sdl2_compat.c
  src/dynapi/SDL_dynapi.c
)

if(APPLE)
  list(APPEND SDL2COMPAT_SRCS
    "src/sdl2_compat_objc.m"
  )

  find_package(X11)
  if(X11_FOUND)
    include_directories("${X11_INCLUDE_DIR}")
  endif()
  if(POLICY CMP0068)
    cmake_policy(SET CMP0068 NEW)  # on macOS, don't let RPATH affect install_name.
  endif()
endif()

if(WIN32)
  list(APPEND SDL2COMPAT_SRCS
    "src/sdl2_mslibc.c"
    "src/version.rc"
  )
endif()
if(MSVC)
  if(SDL_CPU_X64)
    list(APPEND SDL2COMPAT_SRCS
      "src/sdl2_mslibc_x64.masm"
    )
    enable_language(ASM_MASM)
    set_property(SOURCE "src/sdl2_mslibc_x64.masm" PROPERTY LANGUAGE "ASM_MASM")
  elseif(SDL_CPU_ARM64)
    list(APPEND SDL2COMPAT_SRCS
      "src/sdl2_mslibc_arm64.masm"
    )
    enable_language(ASM_MARMASM)
    set_property(SOURCE "src/sdl2_mslibc_arm64.masm" PROPERTY LANGUAGE "ASM_MARMASM")
  elseif(SDL_CPU_ARM32)
    # FIXME: Add ARM32 _chkstk implementation
  endif()
endif()

if(APPLE)
  foreach(SOURCE_FILE ${SDL2COMPAT_SRCS})
    get_filename_component(FILE_EXTENSION ${SOURCE_FILE} EXT)
    if(FILE_EXTENSION STREQUAL "m")
      set_property(SOURCE ${SOURCE_FILE} APPEND_STRING PROPERTY COMPILE_FLAGS " -x objective-c")
    endif()
  endforeach()
endif()

add_library(SDL2 SHARED ${SDL2COMPAT_SRCS})
add_library(SDL2::SDL2 ALIAS SDL2)
SDL_AddCommonCompilerFlags(SDL2 WERROR "${SDL2COMPAT_WERROR}")
target_link_libraries(SDL2 PRIVATE $<BUILD_INTERFACE:SDL3::Headers>)
target_include_directories(SDL2
  INTERFACE
    "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>"
    "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include/SDL2>"
    "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
    "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/SDL2>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/SDL2>"
)
target_compile_definitions(SDL2 PRIVATE "SDL2COMPAT_REVISION=\"${SDL2COMPAT_REVISION}\"")
if(TARGET SDL3::SDL3-shared)
  set_property(TARGET SDL2 PROPERTY BUILD_RPATH $<TARGET_FILE_DIR:SDL3::SDL3-shared>)
endif()

if(MSVC AND SDL_CPU_X64)
  target_compile_options(SDL2 PRIVATE "$<$<COMPILE_LANGUAGE:ASM_MASM>:/nologo>")
endif()
set(EXTRA_CFLAGS )
if(CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
  set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Wall")
  check_c_compiler_flag(-fvisibility=hidden HAVE_FVISIBILITY_HIDDEN)
  if(HAVE_FVISIBILITY_HIDDEN AND (APPLE OR UNIX))
    set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -fvisibility=hidden")
  endif()
  check_c_compiler_flag(-Wdeclaration-after-statement HAVE_WDECLARATION_AFTER_STATEMENT)
  if(HAVE_WDECLARATION_AFTER_STATEMENT)
    set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Wdeclaration-after-statement")
  endif()
  if(SDL2COMPAT_WERROR)
    check_c_compiler_flag(-Werror=declaration-after-statement HAVE_WERROR_DECLARATION_AFTER_STATEMENT)
    if(HAVE_WERROR_DECLARATION_AFTER_STATEMENT)
      set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Werror=declaration-after-statement")
    endif()
  endif()
endif()

check_include_file("winapifamily.h" HAVE_WINAPIFAMILY_H)
if(HAVE_WINAPIFAMILY_H)
  set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -DSDL_HAVE_WINAPIFAMILY_H")
endif()

# This isn't needed for compat libSDL2 who use SDL3 headers.
# SDL2_test and SDL2_main (and the tes programs) still need
# this, because they use SDL2 headers.
check_include_file("immintrin.h" HAVE_IMMINTRIN_H)
if(NOT HAVE_IMMINTRIN_H)
  set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -DSDL_DISABLE_IMMINTRIN_H")
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_CFLAGS}")
string(STRIP "${CMAKE_C_FLAGS}" CMAKE_C_FLAGS)

if(UNIX AND NOT APPLE)
  target_compile_definitions(SDL2 PRIVATE "_REENTRANT")
  target_link_libraries(SDL2 PRIVATE ${CMAKE_DL_LIBS})
endif()
if(ANDROID)
  target_link_libraries(SDL2 PRIVATE log)
endif()
if(APPLE)
  # !!! FIXME: check OUTPUT_NAME value.
  set_target_properties(SDL2 PROPERTIES COMPILE_DEFINITIONS "_THREAD_SAFE")
  target_link_libraries(SDL2 PRIVATE
    "-Wl,-compatibility_version,${SDL_DYLIB_COMPAT_VERSION}"
    "-Wl,-current_version,${SDL_DYLIB_CURRENT_VERSION}"
    "-Wl,-framework,AppKit"
  )
  set_target_properties(SDL2 PROPERTIES
      OUTPUT_NAME "SDL2-2.0"
      SOVERSION "0"
  )
elseif(UNIX AND NOT ANDROID)
  # !!! FIXME: check OUTPUT_NAME value
  set_target_properties(SDL2 PROPERTIES
    OUTPUT_NAME "SDL2-2.0"
    VERSION "${SDL_SO_VERSION}"
    SOVERSION "${SDL_SO_VERSION_MAJOR}"
  )
elseif(WIN32)
  set_target_properties(SDL2 PROPERTIES DEFINE_SYMBOL "DLL_EXPORT")
  # avoid DLL having 'lib' prefix with MinGW
  set_target_properties(SDL2 PROPERTIES
    OUTPUT_NAME "SDL2"
    PREFIX ""
  )
else()
  set_target_properties(SDL2 PROPERTIES
    VERSION "${PROJECT_VERSION}"
    SOVERSION "0"
    OUTPUT_NAME "SDL2"
  )
endif()

if(MINGW)
  set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FLAGS " -nostdlib")
  if(USE_CLANG)
    if(SDL_CPU_X86)
      target_link_libraries(SDL2 PRIVATE clang_rt.builtins-i386)
    endif()
    if(SDL_CPU_X64)
      target_link_libraries(SDL2 PRIVATE clang_rt.builtins-x86_64)
    endif()
  else()
    # need libgcc for emulating 64-bit operations (e.g. 64-bit division) or __chkstk_ms()
    target_link_libraries(SDL2 PRIVATE gcc)
    set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FALGS " -static-libgcc")
  endif()
endif()
if(MSVC)
  # Don't try to link with the default set of libraries.
  target_compile_options(SDL2 PRIVATE "$<$<COMPILE_LANGUAGE:C>:/GS->")
  if(SDL_CPU_X86)  # don't emit SSE2 in x86 builds

=== debian/changelog ===
sdl2-compat (2.30.50+ds-1) unstable; urgency=medium

  * New upstream release
  * d/control: Bump required SDL3 to 3.2.0 stable release
  * d/watch: Watch for official releases
  * Release to unstable

 -- Simon McVittie <smcv@debian.org>  Tue, 21 Jan 2025 21:21:56 +0000

sdl2-compat (2.30.50~git20250116~10a9ed3+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 release candidate 3.1.10
  * Bump SDL3 dependency to 3.1.10
  * d/salsa-ci.yml: Add

 -- Simon McVittie <smcv@debian.org>  Sun, 19 Jan 2025 17:26:32 +0000

sdl2-compat (2.30.50~git20250108~c368587+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 prerelease 3.1.8
  * Bump SDL3 dependency to 3.1.8
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Wed, 08 Jan 2025 16:28:14 +0000

sdl2-compat (2.30.50~git20241102~44a2d4d+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * Bump SDL dependency to 3.1.6 for new APIs used
  * d/rules: Identify the upstream snapshot for SDL_GetRevision()
  * d/not-installed:
    Mark additional license file as intentionally not installed

 -- Simon McVittie <smcv@debian.org>  Mon, 04 Nov 2024 19:06:13 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export SDL_AUDIODRIVER = dummy
export SDL_VIDEODRIVER = dummy

include /usr/share/dpkg/default.mk

built_binaries := $(shell dh_listpackages)
configure_options := \
	-DSDL2COMPAT_STATIC=ON \
	-DSDL2COMPAT_VENDOR_INFO="$(DEB_VENDOR) $(DEB_VERSION)" \
	-DSDL2COMPAT_WERROR=OFF \
	$(NULL)

ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS))$(filter %-tests,$(built_binaries)),nocheck)
configure_options += -DSDL2COMPAT_TESTS=ON
else
configure_options += -DSDL2COMPAT_TESTS=OFF
endif

ifneq ($(filter %-tests,$(built_binaries)),)
configure_options += -DSDL2COMPAT_INSTALL_TESTS=ON
else
configure_options += -DSDL2COMPAT_INSTALL_TESTS=OFF
endif

%:
	dh $@ -Scmake

override_dh_auto_configure:
	echo $(DEB_VERSION_UPSTREAM) > REVISION.txt
	mkdir -p obj-$(DEB_HOST_GNU_TYPE)
	echo '*' > obj-$(DEB_HOST_GNU_TYPE)/.gitignore
	dh_auto_configure -- $(configure_options)

override_dh_install:
	rm -f debian/tmp/usr/include/SDL2/SDL_config.h
	dh_install

override_dh_strip:
	dh_strip -plibsdl2-compat-shim --no-automatic-dbgsym
	dh_strip --remaining-packages

override_dh_makeshlibs:
	dh_makeshlibs -plibsdl2-compat -n
	dh_makeshlibs --remaining-packages
	library=$$(cd debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) && ls -1 libSDL2-2.0.so.0.*) && \
	ln -fns sdl2-compat/$$library debian/libsdl2-compat-shim/usr/lib/$(DEB_HOST_MULTIARCH)/
	ln -fns sdl2-compat/libSDL2-2.0.so.0 debian/libsdl2-compat-shim/usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_shlibdeps:
	dh_shlibdeps -lusr/lib/$(DEB_HOST_MULTIARCH)/sdl2-compat

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-tests
	chmod --recursive a+rX,u+w,og-w debian/*-tests/usr/libexec/installed-tests

override_dh_gencontrol:
	dh_gencontrol -- -Vlocal:EquivalentVersion='2.30.50'

## sdl2-compat 2.30.51+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0...3.28)
-project(sdl2_compat VERSION 2.30.50 LANGUAGES C)
+project(sdl2_compat VERSION 2.30.51 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.

=== debian/changelog ===
sdl2-compat (2.30.51+ds-1) unstable; urgency=medium

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Thu, 30 Jan 2025 10:17:06 +0000

sdl2-compat (2.30.50+ds-2) unstable; urgency=medium

  * Use upstream's SDL_config.h.
    The hope is that in practice, SDL2 games don't rely on the majority
    of the config macros in here.

 -- Simon McVittie <smcv@debian.org>  Wed, 22 Jan 2025 11:20:43 +0000

## sdl2-compat 2.30.52+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0...3.28)
-project(sdl2_compat VERSION 2.30.51 LANGUAGES C)
+project(sdl2_compat VERSION 2.30.52 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.

=== debian/changelog ===
sdl2-compat (2.30.52+ds-1) unstable; urgency=medium

  * New upstream release
  * d/p/testautomation-Verify-that-SIZEOF_VOIDP-has-been-set-corr.patch:
    Add a patch to check that SDL_config.h sets SIZEOF_VOIDP correctly

 -- Simon McVittie <smcv@debian.org>  Mon, 03 Feb 2025 17:15:07 +0000

=== debian/control ===
Source: sdl2-compat
Priority: optional
Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders:
 Simon McVittie <smcv@debian.org>,
 Stephen Kitt <skitt@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libgl-dev <!nocheck> <!noinsttest>,
 libgles-dev [!hurd-any] <!nocheck> <!noinsttest>,
 libsdl3-dev (>= 3.2.0),
 libvulkan-dev <!nocheck> <!noinsttest>,
 libx11-dev <!nocheck> <!noinsttest>,
Standards-Version: 4.7.0
Section: libs
Homepage: https://github.com/libsdl-org/sdl2-compat
Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git
Vcs-Browser: https://salsa.debian.org/sdl-team/sdl2-compat
Rules-Requires-Root: no

Package: libsdl2-compat
Architecture: any
Multi-Arch: same
Depends:
 libsdl3-0 (>= 3.2.0),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: SDL 2 binary compatibility library wrapping SDL 3
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly instead of
 using this layer. Debian packages should not depend or build-depend on
 this package: please use libsdl2-2.0-0 instead.
 .
 This package only provides the library, in a private location, so
 that it can be co-installed with libsdl2-2.0-0. It is intended for
 testing. To replace libsdl2-2.0-0 entirely, and use the compatibility
 layer with all SDL 2 programs, install libsdl2-compat-shim.

Package: libsdl2-compat-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libsdl2-compat-shim (= ${binary:Version}),
 libsdl3-dev (>= 3.2.0),
 pkgconf,
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Conflicts:
 libsdl2-dev,
Provides:
 libsdl2-dev (= ${local:EquivalentVersion}),
Replaces:
 libsdl2-dev,
Description: libsdl2-dev replacement using SDL 3
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly instead
 of using this layer. Debian packages should not build-depend on this
 package: please use libsdl2-dev instead.
 .
 This package provides development files.

Package: libsdl2-compat-shim
Architecture: any
Multi-Arch: same
Depends:
 libsdl2-compat (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libsdl2-2.0-0,
Replaces:
 libsdl2-2.0-0,
Provides:
 libsdl2-2.0-0 (= ${local:EquivalentVersion}),
Description: libsdl2-2.0-0 replacement using SDL 3
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly instead of
 using this layer. Debian packages should not depend or build-depend on
 this package: please use libsdl2-2.0-0 instead.
 .
 This package replaces libsdl2-2.0-0 with the SDL 3 compatibility
 layer, so that all SDL 2 programs will use it.

Package: libsdl2-compat-tests
Build-Profiles: <!noinsttest>
Section: misc
Architecture: any
Depends:
 libsdl2-compat (>= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: SDL 2 binary compatibility library - tests
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly instead of
 using this layer. Debian packages should not depend or build-depend on
 this package.
 .
 This package provides automated and manual test programs.

=== debian/rules ===
--- 
+++ 
@@ -38,10 +38,6 @@
 	echo '*' > obj-$(DEB_HOST_GNU_TYPE)/.gitignore
 	dh_auto_configure -- $(configure_options)
 
-override_dh_install:
-	rm -f debian/tmp/usr/include/SDL2/SDL_config.h
-	dh_install
-
 override_dh_strip:
 	dh_strip -plibsdl2-compat-shim --no-automatic-dbgsym
 	dh_strip --remaining-packages

## sdl2-compat 2.30.54+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0...3.28)
-project(sdl2_compat VERSION 2.30.52 LANGUAGES C)
+project(sdl2_compat VERSION 2.30.54 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.

=== debian/changelog ===
sdl2-compat (2.30.54+ds-1) unstable; urgency=medium

  * New upstream release
  * Increase required SDL3 version to 3.2.4.
    The new SDL_StretchSurface() is now required.
  * d/p/testautomation-Verify-that-SIZEOF_VOIDP-has-been-set-corr.patch:
    Drop patch, applied upstream
  * d/rules: Treat testtimer as flaky when running on non-x86, non-aarch64.
    There is an assertion that requesting a 1ms delay does not result
    in a delay of more than 100ms, and that isn't reliably true on slow
    machines like riscv64 or batch-processing-oriented machines like
    s390x, resulting in intermittent autopkgtest failures.
    This makes those machines unsuitable for playing fast-paced SDL-based
    games, but we already knew that.

 -- Simon McVittie <smcv@debian.org>  Fri, 07 Feb 2025 19:03:04 +0000

## sdl2-compat 2.32.50+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0...3.28)
-project(sdl2_compat VERSION 2.30.54 LANGUAGES C)
+project(sdl2_compat VERSION 2.32.50 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.

=== debian/changelog ===
sdl2-compat (2.32.50+ds-1) unstable; urgency=medium

  * New upstream release
  * d/patches: Add post-release bug fixes from upstream,
    up to release-2.32.50-6-g2a42b90, excluding Windows-specific changes

 -- Simon McVittie <smcv@debian.org>  Mon, 10 Feb 2025 17:49:44 +0000

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  debhelper-compat (= 13),
  libgl-dev <!nocheck> <!noinsttest>,
  libgles-dev [!hurd-any] <!nocheck> <!noinsttest>,
- libsdl3-dev (>= 3.2.0),
+ libsdl3-dev (>= 3.2.4),
  libvulkan-dev <!nocheck> <!noinsttest>,
  libx11-dev <!nocheck> <!noinsttest>,
 Standards-Version: 4.7.0
@@ -23,7 +23,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libsdl3-0 (>= 3.2.0),
+ libsdl3-0 (>= 3.2.4),
  ${misc:Depends},
  ${shlibs:Depends},
 Pre-Depends:
@@ -47,7 +47,7 @@
 Multi-Arch: same
 Depends:
  libsdl2-compat-shim (= ${binary:Version}),
- libsdl3-dev (>= 3.2.0),
+ libsdl3-dev (>= 3.2.4),
  pkgconf,
  ${misc:Depends},
  ${shlibs:Depends},

=== debian/rules ===
--- 
+++ 
@@ -38,6 +38,18 @@
 	echo '*' > obj-$(DEB_HOST_GNU_TYPE)/.gitignore
 	dh_auto_configure -- $(configure_options)
 
+# Only run testtimer as an autopkgtest on machines that we're reasonably
+# sure are both fast and set up to be usable for interactive use
+# (currently only x86 and 64-bit ARM).
+# There is an assertion that requesting a 1ms delay does not result in
+# a delay of more than 100ms, and that's not going to be reliably true
+# on slow machines like riscv64 or batch-processing-oriented machines
+# like s390x.
+ifeq (,$(filter amd64 arm64 i386,$(DEB_HOST_ARCH)))
+execute_after_dh_auto_install:
+	rm -fv debian/tmp/usr/share/installed-tests/SDL2_compat/testtimer.test
+endif
+
 override_dh_strip:
 	dh_strip -plibsdl2-compat-shim --no-automatic-dbgsym
 	dh_strip --remaining-packages

=== debian/watch ===
version=4
# Upstream releases official source tarballs, so we use
# those in preference to git tags
opts="\
    compression=xz, \
    dversionmangle=s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//, \
    downloadurlmangle=s#/tag/#/download/#;s#((?:prerelease|preview|release)-?@ANY_VERSION@)$#$1/sdl2-compat-$2.tar.gz#, \
    filenamemangle=s#(?:prerelease|preview|release)-?@ANY_VERSION@#sdl2-compat-$1.tar.gz#, \
    pgpmode=none, \
    repack, \
    repacksuffix=+ds" \
https://github.com/libsdl-org/sdl2-compat/tags .*/releases/tag/(?:release)-?@ANY_VERSION@

## sdl2-compat 2.32.52+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0...3.28)
-project(sdl2_compat VERSION 2.32.50 LANGUAGES C)
+project(sdl2_compat VERSION 2.32.52 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.
@@ -84,6 +84,7 @@
 cmake_dependent_option(SDL2COMPAT_INSTALL_CPACK "Create binary SDL2_compat archive using CPack" ${SDL2COMPAT_MAINPROJECT} "SDL2COMPAT_INSTALL" OFF)
 cmake_dependent_option(SDL2COMPAT_INSTALL_TESTS "Install test-cases" OFF "SDL2COMPAT_INSTALL;SDL2COMPAT_TESTS" OFF)
 cmake_dependent_option(SDL2COMPAT_INSTALL_SDL3 "Install SDL3 next to SDL2" OFF "WIN32;SDL2COMPAT_INSTALL" OFF)
+option(SDL2COMPAT_ASAN "Use AddressSanitizer to detect memory errors" OFF)
 option(SDL2COMPAT_STATIC "Enable building static SDL2 link library" OFF)
 option(SDL2COMPAT_WERROR "Treat warnings as errors" OFF)
 set(SDL2COMPAT_VENDOR_INFO "" CACHE STRING "Vendor name and/or version to add to SDL_REVISION")
@@ -92,6 +93,61 @@
 
 if(SDL2COMPAT_STATIC AND NOT (CMAKE_SYSTEM_NAME MATCHES "Linux"))
   message(FATAL_ERROR "Static builds are only supported on Linux.")
+endif()
+
+macro(check_add_debug_flag FLAG SUFFIX)
+  check_c_compiler_flag(${FLAG} HAS_C_FLAG_${SUFFIX})
+  if(HAS_C_FLAG_${SUFFIX})
+    string(APPEND CMAKE_C_FLAGS_DEBUG " ${FLAG}")
+  endif()
+endmacro()
+
+macro(asan_check_add_debug_flag ASAN_FLAG)
+  check_add_debug_flag("-fsanitize=${ASAN_FLAG}" "${ASAN_FLAG}")
+  if(HAS_C_${ASAN_FLAG} OR HAS_CXX_${ASAN_FLAG})
+    set(HAVE_ASAN ON)
+  endif()
+endmacro()
+
+macro(asan_check_add_debug_flag2 ASAN_FLAG)
+  # for some sanitize flags we have to manipulate the CMAKE_REQUIRED_LIBRARIES:
+  # http://cmake.3232098.n2.nabble.com/CHECK-CXX-COMPILER-FLAG-doesn-t-give-correct-result-for-fsanitize-address-tp7600216p7600217.html
+
+  set(FLAG "-fsanitize=${ASAN_FLAG}")
+
+  cmake_push_check_state()
+  list(APPEND CMAKE_REQUIRED_LIBRARIES ${FLAG} asan)
+
+  check_c_compiler_flag (${FLAG} HAS_C_FLAG_${ASAN_FLAG})
+  if (HAS_C_FLAG_${ASAN_FLAG})
+    string(APPEND CMAKE_C_FLAGS_DEBUG " ${FLAG}")
+  endif()
+
+  cmake_pop_check_state()
+  if(HAS_C_${ASAN_FLAG} OR HAS_CXX_${ASAN_FLAG})
+    set(HAVE_ASAN ON)
+  endif()
+endmacro()
+
+# enable AddressSanitizer if supported
+if(SDL2COMPAT_ASAN)
+  asan_check_add_debug_flag2("address")
+  asan_check_add_debug_flag("bool")
+  asan_check_add_debug_flag("bounds")
+  asan_check_add_debug_flag("enum")
+  asan_check_add_debug_flag("float-cast-overflow")
+  asan_check_add_debug_flag("float-divide-by-zero")
+  asan_check_add_debug_flag("nonnull-attribute")
+  asan_check_add_debug_flag("returns-nonnull-attribute")
+  asan_check_add_debug_flag("signed-integer-overflow")
+  asan_check_add_debug_flag("undefined")
+  asan_check_add_debug_flag("vla-bound")
+  asan_check_add_debug_flag("leak")
+  # The object size sanitizer has no effect on unoptimized builds on Clang,
+  # but causes warnings.
+  if(NOT USE_CLANG OR CMAKE_BUILD_TYPE STREQUAL "")
+    asan_check_add_debug_flag("object-size")
+  endif()
 endif()
 
 SDL_DetectCompiler()
@@ -267,65 +323,3 @@
   set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -DSDL_DISABLE_IMMINTRIN_H")
 endif()
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_CFLAGS}")
-string(STRIP "${CMAKE_C_FLAGS}" CMAKE_C_FLAGS)
-
-if(UNIX AND NOT APPLE)
-  target_compile_definitions(SDL2 PRIVATE "_REENTRANT")
-  target_link_libraries(SDL2 PRIVATE ${CMAKE_DL_LIBS})
-endif()
-if(ANDROID)
-  target_link_libraries(SDL2 PRIVATE log)
-endif()
-if(APPLE)
-  # !!! FIXME: check OUTPUT_NAME value.
-  set_target_properties(SDL2 PROPERTIES COMPILE_DEFINITIONS "_THREAD_SAFE")
-  target_link_libraries(SDL2 PRIVATE
-    "-Wl,-compatibility_version,${SDL_DYLIB_COMPAT_VERSION}"
-    "-Wl,-current_version,${SDL_DYLIB_CURRENT_VERSION}"
-    "-Wl,-framework,AppKit"
-  )
-  set_target_properties(SDL2 PROPERTIES
-      OUTPUT_NAME "SDL2-2.0"
-      SOVERSION "0"
-  )
-elseif(UNIX AND NOT ANDROID)
-  # !!! FIXME: check OUTPUT_NAME value
-  set_target_properties(SDL2 PROPERTIES
-    OUTPUT_NAME "SDL2-2.0"
-    VERSION "${SDL_SO_VERSION}"
-    SOVERSION "${SDL_SO_VERSION_MAJOR}"
-  )
-elseif(WIN32)
-  set_target_properties(SDL2 PROPERTIES DEFINE_SYMBOL "DLL_EXPORT")
-  # avoid DLL having 'lib' prefix with MinGW
-  set_target_properties(SDL2 PROPERTIES
-    OUTPUT_NAME "SDL2"
-    PREFIX ""
-  )
-else()
-  set_target_properties(SDL2 PROPERTIES
-    VERSION "${PROJECT_VERSION}"
-    SOVERSION "0"
-    OUTPUT_NAME "SDL2"
-  )
-endif()
-
-if(MINGW)
-  set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FLAGS " -nostdlib")
-  if(USE_CLANG)
-    if(SDL_CPU_X86)
-      target_link_libraries(SDL2 PRIVATE clang_rt.builtins-i386)
-    endif()
-    if(SDL_CPU_X64)
-      target_link_libraries(SDL2 PRIVATE clang_rt.builtins-x86_64)
-    endif()
-  else()
-    # need libgcc for emulating 64-bit operations (e.g. 64-bit division) or __chkstk_ms()
-    target_link_libraries(SDL2 PRIVATE gcc)
-    set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FALGS " -static-libgcc")
-  endif()
-endif()
-if(MSVC)
-  # Don't try to link with the default set of libraries.
-  target_compile_options(SDL2 PRIVATE "$<$<COMPILE_LANGUAGE:C>:/GS->")
-  if(SDL_CPU_X86)  # don't emit SSE2 in x86 builds

=== debian/changelog ===
sdl2-compat (2.32.52+ds-3) unstable; urgency=medium

  * d/p/Fixed-creating-exclusive-fullscreen-windows.patch:
    Cherry-pick patch from upstream to fix exclusive fullscreen modes.
    Various older games use these, and they need some adjustment to the
    SDL3 way of doing fullscreen and video modes.
  * d/p/debian/test-Disable-audio-test-case-that-fails-in-a-chroot-conta.patch:
    Drop workaround patch so all tests are run.
    The test that was skipped is believed to have been fixed upstream.
  * Standards-Version: 4.7.2 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Wed, 05 Mar 2025 10:13:47 +0000

sdl2-compat (2.32.52+ds-2) unstable; urgency=medium

  * d/control, d/rules: Link the Provides to the upstream version number.
    Now that sdl2-compat is coupled to the stable ABI of classic SDL2,
    we don't need this to be separate.

 -- Simon McVittie <smcv@debian.org>  Mon, 03 Mar 2025 11:57:35 +0000

sdl2-compat (2.32.52+ds-1) unstable; urgency=medium

  * New upstream release, functionally equivalent to previous snapshot
  * d/control: Depend on SDL 3.2.6 as per CMakeLists.txt

 -- Simon McVittie <smcv@debian.org>  Mon, 03 Mar 2025 11:03:40 +0000

sdl2-compat (2.32.50+git20250228~4a8b718+ds-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Fri, 28 Feb 2025 13:52:39 +0000

sdl2-compat (2.32.50+git20250217~765e74f+ds-1) experimental; urgency=medium

  * d/watch.git: Update
  * d/gbp.conf, d/watch: Watch for git snapshots
  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Wed, 19 Feb 2025 15:34:14 +0000

=== debian/control ===
--- 
+++ 
@@ -9,10 +9,10 @@
  debhelper-compat (= 13),
  libgl-dev <!nocheck> <!noinsttest>,
  libgles-dev [!hurd-any] <!nocheck> <!noinsttest>,
- libsdl3-dev (>= 3.2.4),
+ libsdl3-dev (>= 3.2.6),
  libvulkan-dev <!nocheck> <!noinsttest>,
  libx11-dev <!nocheck> <!noinsttest>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/libsdl-org/sdl2-compat
 Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git
@@ -23,7 +23,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libsdl3-0 (>= 3.2.4),
+ libsdl3-0 (>= 3.2.6),
  ${misc:Depends},
  ${shlibs:Depends},
 Pre-Depends:
@@ -47,7 +47,7 @@
 Multi-Arch: same
 Depends:
  libsdl2-compat-shim (= ${binary:Version}),
- libsdl3-dev (>= 3.2.4),
+ libsdl3-dev (>= 3.2.6),
  pkgconf,
  ${misc:Depends},
  ${shlibs:Depends},
@@ -56,7 +56,7 @@
 Conflicts:
  libsdl2-dev,
 Provides:
- libsdl2-dev (= ${local:EquivalentVersion}),
+ libsdl2-dev (= ${binary:Version}),
 Replaces:
  libsdl2-dev,
 Description: libsdl2-dev replacement using SDL 3
@@ -80,7 +80,7 @@
 Replaces:
  libsdl2-2.0-0,
 Provides:
- libsdl2-2.0-0 (= ${local:EquivalentVersion}),
+ libsdl2-2.0-0 (= ${binary:Version}),
 Description: libsdl2-2.0-0 replacement using SDL 3
  sdl2-compat provides a binary compatible API for programs built
  against SDL 2, but using SDL 3.

## sdl2-compat 2.32.54+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0...3.28)
-project(sdl2_compat VERSION 2.32.52 LANGUAGES C)
+project(sdl2_compat VERSION 2.32.54 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.

=== debian/changelog ===
sdl2-compat (2.32.54+ds-1) unstable; urgency=medium

  * New upstream release
  * d/p/Fixed-creating-exclusive-fullscreen-windows.patch:
    Drop patch, fixed upstream
  * d/control: Require SDL 3.2.10
  * d/*.install, d/*.links: Adjust to rename of sdl2-compat.pc.
    This was previously sdl2_compat.pc. Keep a symlink for the old name
    for trixie (to be removed during the forky cycle) just in case anyone
    is relying on it, but nothing in Debian should be using these names
    anyway: the interoperable way to link to either classic SDL2 or
    sdl2-compat is to use sdl2.pc.

 -- Simon McVittie <smcv@debian.org>  Tue, 01 Apr 2025 14:45:09 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  debhelper-compat (= 13),
  libgl-dev <!nocheck> <!noinsttest>,
  libgles-dev [!hurd-any] <!nocheck> <!noinsttest>,
- libsdl3-dev (>= 3.2.6),
+ libsdl3-dev (>= 3.2.10),
  libvulkan-dev <!nocheck> <!noinsttest>,
  libx11-dev <!nocheck> <!noinsttest>,
 Standards-Version: 4.7.2
@@ -23,7 +23,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libsdl3-0 (>= 3.2.6),
+ libsdl3-0 (>= 3.2.10),
  ${misc:Depends},
  ${shlibs:Depends},
 Pre-Depends:
@@ -47,7 +47,7 @@
 Multi-Arch: same
 Depends:
  libsdl2-compat-shim (= ${binary:Version}),
- libsdl3-dev (>= 3.2.6),
+ libsdl3-dev (>= 3.2.10),
  pkgconf,
  ${misc:Depends},
  ${shlibs:Depends},

=== debian/tests/control ===
Tests: build
Depends: build-essential, clang:native, libsdl2-compat-dev
Restrictions: allow-stderr, superficial

Tests: deprecated-use
Depends: build-essential, clang:native, libsdl2-compat-dev, libsdl2-ttf-dev
Restrictions: allow-stderr, superficial

Tests: cmake
Depends: build-essential, cmake, libsdl2-compat-dev
Restrictions: allow-stderr, superficial

Tests: flaky
Depends: libsdl2-compat-tests
Restrictions: allow-stderr, flaky, superficial

Tests: installed-tests
Depends: gnome-desktop-testing, libsdl2-compat-tests
Restrictions: allow-stderr

## sdl2-compat 2.32.56%2Bgit20251003~dbb14db%2Bds

=== debian/watch ===
Version: 5

Source: https://github.com/libsdl-org/sdl2-compat.git
Matching-Pattern: HEAD
Compression: xz
Dversion-Mangle: s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//
Mode: git
Pgp-Mode: none
Git-Pretty: 2.32.56+git%cd~%h
Repack: yes
Repack-Suffix: +ds

## sdl2-compat 2.32.56+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0...3.28)
-project(sdl2_compat VERSION 2.32.54 LANGUAGES C)
+project(sdl2_compat VERSION 2.32.56 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.

=== debian/changelog ===
sdl2-compat (2.32.56+ds-3) unstable; urgency=medium

  * d/README.Debian: Improve test instructions
  * d/p/init-If-using-sdl2-compat-s-debug-logging-also-turn-on-SD.patch,
    d/p/dynapi-Under-SDL2COMPAT_DEBUG_LOGGING-log-whether-we-were.patch:
    Add patches from upstream to improve debug output.
    This is especially important when combining
    SDL2COMPAT_DEBUG_LOGGING=1, libsdl2-compat-shim, libsdl2-classic,
    and SDL_DYNAMIC_API='/usr/$LIB/sdl2-classic/libSDL2-2.0.so.0',
    to leave a trace on stderr that we were replaced with classic SDL2.

 -- Simon McVittie <smcv@debian.org>  Fri, 12 Sep 2025 15:56:01 +0100

sdl2-compat (2.32.56+ds-2) unstable; urgency=medium

  * Rebuild for unstable

 -- Simon McVittie <smcv@debian.org>  Sun, 10 Aug 2025 11:24:45 +0100

sdl2-compat (2.32.56+ds-1) experimental; urgency=medium

  * New upstream release
    - Fix misleading documentation for SDL_BlitRect()
    - Fix brightness for ioquake3 by reporting SDL_SetWindowGammaRamp()
      as unimplemented
    - Fix corrupted music in OpenRCT2, which plays mono audio that we
      need to convert to stereo
    - Always return a fallback refresh rate and pixel format for
      display modes
    - Make fullscreen behaviour more compatible with classic SDL2
    - Never return any flags from SDL_GetWindowFlags(NULL)
    - Fix a memory leak in SDL_LockTextureToSurface()
    - Avoid including <immintrin.h> on non-x86 if HAVE_IMMINTRIN_H
      somehow gets defined
    - Add quirks table entries for several games that assume X11 and will
      crash if we try to use native Wayland
    - Only compile in X11-specific quirks on Unix platforms
    - Skip rendering textures with a zero-size source rectangle
    - Avoid variable name 'pixel' for symmetry with SDL3
    - Annotate the automated tests with intentional differences from
      classic SDL2
    - Changes specific to macOS and Windows not further documented here
  * d/control: Require SDL 3.2.12

 -- Simon McVittie <smcv@debian.org>  Tue, 06 May 2025 21:17:13 +0100

=== debian/rules ===
--- 
+++ 
@@ -69,6 +69,3 @@
 override_dh_fixperms:
 	dh_fixperms -Xusr/libexec/installed-tests
 	chmod --recursive a+rX,u+w,og-w debian/*-tests/usr/libexec/installed-tests
-
-override_dh_gencontrol:
-	dh_gencontrol -- -Vlocal:EquivalentVersion='2.30.50'

## sdl2-compat 2.32.56+git20250804~459c48d+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0...3.28)
-project(sdl2_compat VERSION 2.32.56 LANGUAGES C)
+project(sdl2_compat VERSION 2.32.57 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.
@@ -223,15 +223,16 @@
   src/dynapi/SDL_dynapi.c
 )
 
+if(UNIX AND NOT ANDROID)
+  find_package(X11 REQUIRED)
+  include_directories(${X11_INCLUDE_DIR})
+endif()
+
 if(APPLE)
   list(APPEND SDL2COMPAT_SRCS
     "src/sdl2_compat_objc.m"
   )
 
-  find_package(X11)
-  if(X11_FOUND)
-    include_directories("${X11_INCLUDE_DIR}")
-  endif()
   if(POLICY CMP0068)
     cmake_policy(SET CMP0068 NEW)  # on macOS, don't let RPATH affect install_name.
   endif()

=== debian/changelog ===
sdl2-compat (2.32.56+git20250804~459c48d+ds-1) experimental; urgency=medium

  * d/gbp.conf, d/watch: Watch for git snapshots
  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Tue, 05 Aug 2025 19:05:30 +0100

## sdl2-compat 2.32.56+git20250910~8df91f9+ds

=== debian/changelog ===
sdl2-compat (2.32.56+git20250910~8df91f9+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * Merge packaging from unstable
    - Drop patches added by 2.32.56+ds-3, included in the new upstream
      snapshot
  * d/control: Track debian/snapshots branch in Vcs-Git, matching d/gbp.conf
  * d/watch.git: Convert to v5
  * d/source/lintian-overrides: Silence a false-positive for d/watch v5

 -- Simon McVittie <smcv@debian.org>  Fri, 12 Sep 2025 18:14:49 +0100

=== debian/control ===
--- 
+++ 
@@ -9,13 +9,13 @@
  debhelper-compat (= 13),
  libgl-dev <!nocheck> <!noinsttest>,
  libgles-dev [!hurd-any] <!nocheck> <!noinsttest>,
- libsdl3-dev (>= 3.2.10),
+ libsdl3-dev (>= 3.2.12),
  libvulkan-dev <!nocheck> <!noinsttest>,
  libx11-dev <!nocheck> <!noinsttest>,
 Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/libsdl-org/sdl2-compat
-Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git
+Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git -b debian/snapshots
 Vcs-Browser: https://salsa.debian.org/sdl-team/sdl2-compat
 Rules-Requires-Root: no
 
@@ -23,7 +23,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libsdl3-0 (>= 3.2.10),
+ libsdl3-0 (>= 3.2.12),
  ${misc:Depends},
  ${shlibs:Depends},
 Pre-Depends:
@@ -47,7 +47,7 @@
 Multi-Arch: same
 Depends:
  libsdl2-compat-shim (= ${binary:Version}),
- libsdl3-dev (>= 3.2.10),
+ libsdl3-dev (>= 3.2.12),
  pkgconf,
  ${misc:Depends},
  ${shlibs:Depends},

## sdl2-compat 2.32.56+git20250924~1577bce+ds

=== debian/changelog ===
sdl2-compat (2.32.56+git20250924~1577bce+ds-1) experimental; urgency=medium

  * New upstream snapshot release-2.32.56-36-g1577bce
  * d/upstream/signing-key.asc: Add.
    This is not directly useful for git snapshots, but can be used for
    the next signed tarball release.
  * d/watch*: Convert to uscan format v5

 -- Simon McVittie <smcv@debian.org>  Fri, 26 Sep 2025 10:14:24 +0100

=== debian/watch ===
--- 
+++ 
@@ -8,4 +8,4 @@
 Pgp-Mode: none
 Git-Pretty: 2.32.56+git%cd~%h
 Repack: yes
-Repack-Suffix: +ds
+Repacksuffix: +ds

## sdl2-compat 2.32.56+git20250930~792fc7b+ds

=== debian/changelog ===
sdl2-compat (2.32.56+git20250930~792fc7b+ds-1) experimental; urgency=medium

  * New upstream snapshot, release-2.32.56-40-g792fc7b
  * d/rules: Put the SDL- prefix on REVISION.txt.
    This means we can extract version info from the binary with strings(1)
    and grep(1), the same as for "classic" SDL2.
  * d/rules: Only create REVISION.txt if it doesn't already exist
  * d/control, d/rules: Build using ninja
  * d/rules: Do the build in a directory covered by upstream's .gitignore
  * d/control: Remove Rules-Requires-Root, no longer needed since Debian 13
  * Reformat packaging files using debputy
  * Remove sdl2_compat.pc compatibility symlink temporarily added
    in 2.32.54+ds-1

 -- Simon McVittie <smcv@debian.org>  Tue, 30 Sep 2025 17:37:46 +0100

=== debian/rules ===
--- 
+++ 
@@ -30,12 +30,10 @@
 endif
 
 %:
-	dh $@ -Scmake
+	dh $@ -Scmake+ninja -Bcmake-build
 
 override_dh_auto_configure:
-	echo $(DEB_VERSION_UPSTREAM) > REVISION.txt
-	mkdir -p obj-$(DEB_HOST_GNU_TYPE)
-	echo '*' > obj-$(DEB_HOST_GNU_TYPE)/.gitignore
+	test -e REVISION.txt || echo SDL-$(DEB_VERSION_UPSTREAM) > REVISION.txt
 	dh_auto_configure -- $(configure_options)
 
 # Only run testtimer as an autopkgtest on machines that we're reasonably
